﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// Add a reference to System.Management.
using System.Management;

// For more information on the Win32_PnPEntity class, see:
// http://msdn.microsoft.com/en-us/library/windows/desktop/aa394353%28v=vs.85%29.aspx

namespace howto_list_usb_devices
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ManagementObjectSearcher device_searcher =
                new ManagementObjectSearcher("SELECT * FROM Win32_USBHub");
            foreach (ManagementObject usb_device in device_searcher.Get())
            {
                ListViewItem new_item = lvwDevices.Items.Add(usb_device.Properties["DeviceID"].Value.ToString());
                new_item.SubItems.Add(usb_device.Properties["PNPDeviceID"].Value.ToString());
                new_item.SubItems.Add(usb_device.Properties["Description"].Value.ToString());
            }
        }
    }
}
